--[[ ä

	Name: Advanced Questbook
	By: Crypton

]]
-- Help topics will be added back later. I need to rewrite them.
-- UI Items
AQB_XML_QDTAILS = "Quest Details";
AQB_XML_DESCR = "Description:";
AQB_XML_REWARDS = "Rewards:";
AQB_XML_DETAILS = "Details:";
AQB_XML_LOCATIONS = "Locations:";
AQB_XML_CONFIG = "Config";
AQB_XML_HSECTION = "Help Section";
AQB_XML_OPENHELP = "Open Help";
AQB_XML_CLOSEHELP = "Close Help";
AQB_XML_SHARERES = "Share Results";
AQB_XML_SHOWSHARE = "Show Shared";
AQB_XML_HIDESHARE = "Hide Shared";
AQB_XML_BACK = "Back";
AQB_XML_TYPEKEYWORD = "Type a keyword to search";
AQB_XML_SEARCH = "Search";
AQB_XML_SEARCHRES = "Search Results";
AQB_XML_CONFIG2 = "Configuration";
AQB_XML_RELOADUI1 = "ReloadUI";
AQB_XML_RELOADUI2 = "Reload UI if the map icons get messed up.";
AQB_XML_RELOADUI3 = "AQD Enabled, ReloadUI Disabled.";
AQB_XML_SHTOOLTIPS = "Show Tooltips";
AQB_XML_STTOOLTIPS = "Sticky Tooltips";
AQB_XML_STICONS = "Sticky Icons";
AQB_XML_QDONTIPS = "Quest Description on Tooltips";
AQB_XML_RLONTIPS = "Recommended Level on Tooltips";
AQB_XML_REWONTIPS = "Rewards on Tooltips";
AQB_XML_COORDONTIPS = "Coordinates on Tooltips";
AQB_XML_PREINC = "Preserve Incomplete";
AQB_XML_AQD = "Advanced Quest Dumper";
AQB_XML_QS = "Quest Share";
AQB_XML_TMBTN = "Toggle Minibutton";
AQB_XML_SAVECLOSE = "Save/Close";
AQB_XML_CLOSECONFIG = "Close Config";
AQB_XML_PURGE = "Clear Data";
AQB_XML_STPORT = "Snoop Transport on World Map";
AQB_XML_ETRAIN = "Elite Trainers on World Map";
AQB_XML_SHOWSHARED = "Show Shared on World Map";
AQB_XML_MSGONDUMP = "Show message on Quest Dump";
--[[
	%s is a "Wild Card" character. AQB uses these to replace with data
	such as names of items, players, etc.. It is important not to remove
	them or you will receive errors. For translating, you can move them
	where they need to go in the sentence so the data forms a proper
	sentence in your language.
]]
AdvQuestBook_Messages = {
	["AQB_AMINFO"] = "a feature rich way to find information, track, and manage your ingame quests.",
	["AQB_AMNOTFOUND"] = "AddonManager not detected. It is a useful addon and highly recommended to use for %s. Type %s to open the %s panel or you can use the provided button that appears when AddonManager is not installed.",
	["AQB_ERRFILELOAD"] = "Error loading file",
	["AQB_DFAULTSETLOAD"] = "default settings loaded",
	["AQB_SETSUPDATE"] = "updated settings",
	["AQB_GET_PQUEST"] = "Get Party Quests",
	["AQB_SHIFT_RIGHT"] = "Shift + Right Click to move the minimap buttons.",
	["AQB_RCLICK"] = "Right Click",
	["AQB_MOVE_BTN"] = "Hold down left mouse button to move button.",
	["AQB_L50ET"] = "Must have Primary and Secondary Level 45 Elite Skills.",
	["AQB_LIST_RECIEVED"] = "Recieved Quest Share List. Please open %s to see shared quests.",
	["AQB_NOLIST_RECIEVED"] = "No Shared Quest data was received.",
	["AQB_RECLEVEL"] = "Recommended Level",
	["AQB_UNKNOWNQID"] = "Unknown Quest ID",
	["AQB_COORDS"] = "Coords",
	["AQB_NEW_QD"] = "New Quest Dumped for %s.";
	["AQB_CLEARED_DATA"] = "Cleaned out %s Quests and Saved %s Quests",
	["AQB_CLEANED_ALL"] = "Cleaned out all saved quest data.",
	["AQB_UPLOAD"] = "Be sure to upload your %s to %s after you have exited the game.",
	["AQB_MIN_CHARS"] = "Please type at least %s characters to search...",
	["AQB_TOOMANY"] = "More than %s results found. Using a different search term may reduce your results to something easier to look through.",
	["AQB_SEARCHING"] = "Searching for %s. Please wait...",
	["AQB_FOUND_RESULTS"] = "Found %s results for %s.",
	["AQB_NOTSUB"] = "This quest has not been submitted yet.",
	["AQB_RECLEVEL"] = "Recommended Level",
	["AQB_START"] = "Start",
	["AQB_END"] = "End",
	["AQB_REWARDS"] = "Rewards",
	["AQB_COORDS"] = "Coords",
	["AQB_TRANSPORT"] = "Transport",
	["AQB_LINKSTO"] = "Links To",
	["AQB_DUMPED"] = "Dumped",
	["AQB_GOLD"] = "Gold",
	["AQB_XP"] = "Experience",
	["AQB_TP"] = "Talent Points",
	["AQB_MAP"] = "Map",
	["AQB_AND"] = "and",
	["AQB_OPEN"] = "Open",
	["AQB_LOCK"] = "Lock",
	["AQB_UNLOCK"] = "Unlock",
	["AQB_QSTATUS0"] = "You have not completed this quest.",
	["AQB_QSTATUS1"] = "You currently have this quest.",
	["AQB_QSTATUS2"] = "You have completed this quest.",
};

AQB_MAP_NAMES = {
	[1] = "Howling Mountains",
	[2] = "Silverspring",
	[3] = "Revenfell",
	[4] = "Aslan Valley",
	[5] = "Ystra Highlands",
	[6] = "Dust Devil Canyon",
	[7] = "Weeping Coast",
	[8] = "Savage Lands",
	[9] = "Aotulia Volcano",
	[10] = "Sascilia Steppes",
	[11] = "Dragonfang Ridge",
	[12] = "Elven Island",
	[100] = "Tutorial",
	[101] = "Cavern of Trials",
	[102] = "Forsaken Abbey",
	[103] = "Necropolis of Mirrors",
	[104] = "Mystic Altar",
	[105] = "Queens Chamber",
	[106] = "Pasper\'s Shrine",
	[107] = "Kalin Shrine",
	[108] = "Treasure Trove",
	[110] = "Barren Caves",
	[113] = "Ruins of the Ice Dwarf Kingdom",
	[114] = "Ruins of the Ice Dwarf Kingdom",
	[115] = "Heart of the Ocean",
	[116] = "Origin",
	[201] = "Bloody Gallery",
	[205] = "Revivers\' Corridor",
	[206] = "Guards\' Corridor",
	[207] = "Royals\' Refuge",
	[250] = "Windmill Basement",
	[251] = "Arcane Chamber of Sathkur",
	[252] = "Cyclops Lair",
	[301] = "Fungus Garden",
	[400] = "Residence",
	[401] = "Guild Castle",
	[9999] = "Candara",
	[10000] = "Varanas",
	[10001] = "Obsidian Stronghold",
};

AQB_CLASSES = {
	["AQB_KNIGHT"] = "Knight",
	["AQB_ROGUE"] = "Rogue",
	["AQB_PRIEST"] = "Priest",
	["AQB_MAGE"] = "Mage",
	["AQB_WARRIOR"] = "Warrior",
	["AQB_SCOUT"] = "Scout",
	["AQB_ELVEN"] = "Elven",
	["AQB_WARDEN"] = "Warden",
};

AQB_ITEM_STRINGS = {
	["AQB_LC"] = "Life Crystal",
	["AQB_IC"] = "Illusion Crystal",
	["AQB_TC"] = "Tough Crystal",
	["AQB_OL"] = "Oak Lumber",
	["AQB_CN"] = "Copper Nugget",
	["AQB_MSAP"] = "Moxa Sap",
	["AQB_ASE"] = "Ancient Spirit Essence",
	["AQB_SE"] = "Study Essence",
	["AQB_ME"] = "Mirror Essence",
	["AQB_AL"] = "Ash Lumber",
	["AQB_ZN"] = "Zinc Nugget",
	["AQB_MDGS"] = "Mountain Demon Grass Sap",
	["AQB_WL"] = "Willow Lumber",
	["AQB_TN"] = "Tin Nugget",
	["AQB_BSAP"] = "Beetroot Sap",
	["AQB_MS"] = "Minotaur\'s Soul",
	["AQB_SOW"] = "Sound of Wind",
	["AQB_HHS"] = "Harpy Holy Spirit",
};

AQB_SNOOP_NAMES = {
	[1] = "Logar",
	[2] = "Varanas",
	[3] = "Abandoned Fortress",
	[4] = "Silverfall",
	[5] = "Harf Trading Post",
	[6] = "Ayen Caravan",
	[7] = "Lyk",
	[8] = "Obsidian Stronghold",
	[9] = "Boulderwind Village",
	[10] = "Haven of Departure",
	[11] = "Green Tower",
	[12] = "Titans\' Hill",
};

AQB_AIRSHIP_NAMES = {
	[1] = "Haven of Departure\n\nSidklaw\nAirship Captain",
	[2] = "Varanas\n\nAirship Operator",
};
